(二分查找 拓展) leetcode 162. Find Peak Element && lintcode 75. Find Peak Element

A peak element is an element that is greater than its neighbors.

Given an input array nums, where nums[i] ≠ nums[i+1], find a peak element and return its index.

The array may contain multiple peaks, in that case return the index to any one of the peaks is fine.

You may imagine that nums[-1] = nums[n] = -∞.

Example 1:

Input: nums = [1,2,3,1]
Output: 2
Explanation: 3 is a peak element and your function should return the index number 2.

Example 2:

Input: nums = [1,2,1,3,5,6,4]
Output: 1 or 5 
Explanation: Your function can return either index number 1 where the peak element is 2, 
             or index number 5 where the peak element is 6.

Note:

Your solution should be in logarithmic complexity.

-----------------------------------------------------------------------------------------------------------------------------------------

这个在leetcode上用O(n)算法可以过,但是在lintcode 上会超时。

可以用二分查找,二分查找有递归写法和迭代写法。

C++:迭代

class Solution {
public:
    int findPeakElement(vector<int>& nums) {
        if(nums.size() == 0) return -1;
        int left = 0,right = nums.size() - 1;
        int mid;
        while(left < right){
            mid = left + (right - left)/2;
            if(nums[mid] > nums[mid + 1]) right = mid;  //mid不会加1,因为它本身也有可能是“山顶”。
            else left = mid + 1;  //会加1 的,因为nums[mid]肯定不是“山顶”,所以忽略它。
        }
        return left;
    }
};

详情见官方题解:https://leetcode.com/articles/find-peak-element/

另一个迭代解法(在lintcode上):

class Solution {
public:
    /**
     * @param A: An integers array.
     * @return: return any of peek positions.
     */
    int findPeak(vector<int> &A) {
        // write your code here
        if(A.size() == 0) return -1;
        int l = 0,r = A.size() - 1;
        int mid;
        while(l < r){
            mid = l + (r - l)/2;
            if(A[mid] < A[mid - 1])
                r = mid;
            else if(A[mid] < A[mid + 1])
                l = mid + 1;
            else
                return mid;
        }
        //mid = A[l] > A[r] ? l:r;
        //return mid;
    }
};

也有一个解法:

class Solution {
public:
    int findPeakElement(vector<int>& nums) {
        if(nums.size() == 0)
            return -1;
        int left = 0;
        int right = nums.size() - 1;
        while(left + 1< right){
            int mid = left + (right - left)/2;
            if(nums[mid] > nums[mid + 1]) right = mid;
            else if(nums[mid] < nums[mid + 1]) left = mid;
            //else return mid;
        }
        int mid = nums[left] > nums[right] ? left:right;
        return mid;
    }
};